Getting Started with the Kendo UI for Angular TreeList

This guide provides the information you need to start using the Kendo UI for Angular TreeList—it includes instructions about the available installation approaches, the required dependencies, the code for running the project, and links to additional resources.

The TreeList Package is part of Kendo UI for Angular, a professional grade UI library with 110+ components for building modern and feature-rich applications. To try it out sign up for a free 30-day trial.

After the completion of this guide, you will be able to achieve an end result as demonstrated in the following example.

Example
View Source
Change Theme:

Setting Up Your Angular Project

Before you start with the installation of any Kendo UI for Angular control, ensure that you have a running Angular project. The prerequisites to accomplish the installation of the components are always the same regardless of the Kendo UI for Angular package you want to use, and are fully described in the section on setting up your Angular project.

Installing the Component

You can choose to use either of the following two approaches for installing the Kendo UI for Angular package and the styles you want to apply:

Quick Setup with Angular CLI

The quick setup presents an automatic approach for adding packages with Angular CLI through the ng-add command. It is suitable for saving time and efforts as ng-add executes in a single step a set of otherwise individually needed commands.

To add the Kendo UI for Angular TreeList package, run the following command:

ng add @progress/kendo-angular-treelist

As a result, the ng-add command will perform the following actions:

  • Add the @progress/kendo-angular-treelist package as a dependency to the package.json file.
  • Import the TreeListModule in the current application's main module (only if the application uses NgModules).

    If your application uses standalone components, you must import the TreeListModule manually.

  • Register the Kendo UI Default theme in the angular.json file.
  • Add all required peer dependencies to the package.json file.
  • Trigger npm install to install the theme and all peer packages that are added.

Manual Setup

The manual setup provides greater visibility and better control over the files and references installed in your Angular application. You can install the required peer dependencies and a Kendo UI theme by running separate commands for each step and import the desired component modules in your NgModule.

  1. Install the TreeList package together with its dependencies by running the following command:

     npm install --save @progress/kendo-angular-treelist @progress/kendo-angular-dropdowns @progress/kendo-angular-treeview @progress/kendo-angular-inputs @progress/kendo-angular-dateinputs @progress/kendo-data-query @progress/kendo-angular-intl @progress/kendo-angular-l10n @progress/kendo-angular-label @progress/kendo-drawing @progress/kendo-angular-excel-export @progress/kendo-angular-buttons @progress/kendo-angular-common @progress/kendo-angular-pdf-export @progress/kendo-angular-popup @progress/kendo-licensing
  2. To add the TreeList component, import the TreeListModule either in your NgModule or standalone components.

    • Using Modules

      import { NgModule } from '@angular/core';
      import { BrowserModule } from '@angular/platform-browser';
      import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
      import { TreeListModule } from '@progress/kendo-angular-treelist';
      import { AppComponent } from './app.component';
      
      @NgModule({
          imports: [BrowserModule, BrowserAnimationsModule, TreeListModule],
          declarations: [AppComponent],
          bootstrap: [AppComponent]
      })
      
      export class AppModule {}
    • Using Standalone Components

      import { Component } from '@angular/core';
      import { TreeListModule } from '@progress/kendo-angular-treelist';
      
      @Component({
          standalone: true,
          selector: 'my-app',
          imports: [TreeListModule],
          template: `
              <kendo-treelist></kendo-treelist>
          `.
      })
  3. The next step is to style the component by installing one of the available Kendo UI themes—Kendo UI Default, Kendo UI Material, or Kendo UI Bootstrap.

    3.1 To start using a theme, install its package through NPM.

    • Default theme

      npm install --save @progress/kendo-theme-default
    • Bootstrap theme

      npm install --save @progress/kendo-theme-bootstrap
    • Material theme

      npm install --save @progress/kendo-theme-material

    3.2 After the theme package is installed, reference it in your project. You can include kendo-themes in your project in one of the following ways:

Using the Component

  1. After successfully installing the TreeList package and importing its module, add the following code in the app.component.html file:

    <kendo-treelist
        [kendoTreeListFlatBinding]="data"
        kendoTreeListExpandable
        idField="id"
        parentIdField="managerId"
    >
        <kendo-treelist-column [expandable]="true" field="name" title="Name"> </kendo-treelist-column>
        <kendo-treelist-column field="title" title="Title"></kendo-treelist-column>
        <kendo-treelist-column field="phone" title="Phone"></kendo-treelist-column>
    </kendo-treelist>
  2. Bind the kendoTreeListFlatBinding property to an array containing all nodes in the app.component.ts file:

    public data: unknown[] = [
        {
            id: 1,
            name: 'Daryl Sweeney',
            title: 'Chief Executive Officer',
            phone: '(555) 924-9726',
            managerId: null
        },
        {
            id: 2,
            name: 'Guy Wooten',
            title: 'Chief Technical Officer',
            phone: '(438) 738-4935',
            managerId: 1
        },
        /*...*/
    ]
  3. When flat data is used, parent-child relationships are defined by assigning unique ID to an idField property and a parent ID to parentIdField property.

  4. Build and serve the application by running the following command in the root folder.

    ng serve
  5. Point your browser to http://localhost:4200 to see the Kendo UI for Angular TreeList component on the page.

Activating Your License Key

As of December 2020, using any of the UI components from the Kendo UI for Angular library requires either a commercial license key or an active trial license key. If your application does not contain a Kendo UI license file, activate your license key.

Next Steps

Dependencies

The following table lists the specific functionalities that are provided by each of the TreeList dependencies as per package:

Package NameDescription
@angular/commonProvides the commonly-needed services, pipes, and directives provided by the Angular team. For more information, refer to the official Angular documentation.
@angular/coreContains critical runtime parts of the Angular framework that are needed by every application. For more information, refer to the official Angular documentation.
@angular/formsProvides support for both template-driven and reactive forms. For more information, refer to the official Angular documentation.
@angular/animationsContains the library of Angular animations. For more information, refer to the official Angular documentation.
@progress/kendo-angular-buttonsContains the Kendo UI for Angular Buttons components.
@progress/kendo-angular-commonContains common utilities that are needed by every Kendo UI for Angular component.
@progress/kendo-angular-dateinputsContains the Kendo UI for Angular Date Inputs components.
@progress/kendo-angular-dropdownsContains the Kendo UI for Angular Dropdowns components.
@progress/kendo-angular-excel-exportContains the Kendo UI for Angular Excel Export component.
@progress/kendo-angular-inputsContains the Kendo UI for Angular Inputs components.
@progress/kendo-angular-intlProvides the Kendo UI for Angular services and pipes for the parsing and formatting of dates and numbers.
@progress/kendo-angular-l10nProvides the globalization features of Kendo UI for Angular.
@progress/kendo-angular-labelContains the Kendo UI for Angular Label components.
@progress/kendo-angular-pdf-exportContains the Kendo UI for Angular PDF Export component.
@progress/kendo-angular-popupContains the Kendo UI for Angular Popup component.
@progress/kendo-angular-treeviewContains the Kendo UI for Angular TreeView component.
@progress/kendo-data-queryContains the Kendo UI Data Query utilities for applying sorting, filtering, grouping, and aggregate data operations.
@progress/kendo-drawingProvides the Kendo UI cross-browser library for interactive vector graphics.
@progress/kendo-licensingContains the kendo-ui-license CLI Tool for license management and the validatePackage function and type definitions that are used by licensed packages.
rxjsProvides the RxJS library for reactive programming which uses Observables for an easier composition of asynchronous or callback-based code.

Learning Resources

Getting Started with the KendoReact TreeList
Premium

This guide provides essential information about using the KendoReact TreeList package—you will learn how to install the TreeList package, add a TreeList component to your project, style the component, and activate your license.

ninja-iconThe TreeList is part of KendoReact premium, an enterprise-grade UI library with 120+ free and premium components for building polished, performant apps. Test-drive all features with a free 30-day trial.Start Free Trial

After completing this guide, you will be able to reproduce the following example.

Change Theme
Theme
Loading ...

Before You Begin

sh
npm create vite@latest my-app -- --template react

This guide requires that you have basic knowledge of React and TypeScript, and that you have already created a blank React project.

You can speed up the development of your KendoReact application with the Kendo UI Template Wizard for Visual Studio Code.

Install the Component

sh
npm i @progress/kendo-react-treelist

Importing the Component

After installing the package, import the TreeList component in the React App. To enable the sending of messages, also import the Message entity and the TreeListMessageSendEvent.

In the src/App.js file of your React project, import the TreeList component from the TreeList package.

jsx
// ES2015 module syntax
import { TreeList } from "@progress/kendo-react-treelist";
jsx
// CommonJS format
const { TreeList } = require('@progress/kendo-react-treelist');

Using the Component

  1. Get the data for the TreeList.

    jsx
    import data from './simple-data';
  2. Create the columns for the TreeList.

    jsx
    const columns = [
        { field: 'name', title: 'Name', width: '250px', expandable: true },
        { field: 'title', title: 'Title' }
    ];
  3. Specify the field's name, which will provide an array representation of the item subitems.

    jsx
    const subItemsField: string = 'employees';
  4. Specify the field's name, which will provide a Boolean representation of the expanded state of each item.

    jsx
    const expandField = 'expanded';
  5. Add the component's markup to the src/App.js file in your project.

    jsx
    return (
        <TreeList
            style={{ maxHeight: '510px', overflow: 'auto' }}
            expandField={expandField}
            subItemsField={subItemsField}
            data={data}
            columns={columns}
        />
    );
  6. To style the TreeList, install and import the Default theme, which is one of the three beautiful themes for KendoReact.

    6.1. Install the Default theme package.

    sh
    npm i @progress/kendo-theme-default

    6.2. Import the CSS file from the package in src/App.js. Add this import before your existing App.css import.

    jsx
    import '@progress/kendo-theme-default/dist/all.css';
  7. Build and run the application by typing the following command in the root folder of your project:

    sh
    npm start
  8. Navigate to http://localhost:3000 to see the KendoReact TreeList component on the page.

Activating Your License Key

Important: The KendoReact TreeList is a premium component that requires a license key file to be installed in your project. This applies to both trial and commercial usage:

Without a valid license key file, the component will display licensing warnings and watermarks.

Follow the instructions on the KendoReact My License page to download and install your license key file. You can skip this step if your application already contains a KendoReact license file.

Dependencies

The TreeList package requires you to install the following peer dependencies in your application:

Package NameDescription
react 16.8.2*Contains the functionality necessary to define React components.
react-domContains the React renderer for the web.
@progress/kendo-licensingContains the internal infrastructure related to licensing.
@progress/kendo-react-intlContains the KendoReact Internationalization package that applies the desired cultures by providing services and pipes for the parsing and formatting of dates and numbers.
@progress/kendo-data-queryApplies sorting, filtering, grouping, and aggregate data operations.
@progress/kendo-react-animationEnables the animations in the KendoReact components.
@progress/kendo-react-data-toolsDelivers components required to manage and control the data in the application.
@progress/kendo-react-dateinputsContains the KendoReact Date Inputs components that are used to select the date and time for an appointment.
@progress/kendo-react-dropdownsContains the KendoReact Dropdowns, which allows users to choose from a predefined list of options.
@progress/kendo-react-inputsContains the KendoReact Inputs, which the input of data, based on a specific and predefined format.
@progress/kendo-drawingContains the Drawing library, which provides interactive vector graphics.
@progress/kendo-react-buttonsContains the KendoReact Buttons library, which provides buttons.
@progress/kendo-date-mathContains the logic for working with date objects and timezones.
@progress/kendo-svg-iconsContains the KendoReact SVG icons.

Learning Resources